(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else {
		var a = factory();
		for(var i in a) (typeof exports === 'object' ? exports : root)[i] = a[i];
	}
})(self, function() {
return /******/ (() => { // webpackBootstrap
/******/ 	var __webpack_modules__ = ({

/***/ "RXMP":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__("JLQQ");

/***/ }),

/***/ "ZbhI":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__("J6x8");

/***/ }),

/***/ "FLGM":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__("XGjS");

/***/ }),

/***/ "UtpJ":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__("QDXk");

/***/ }),

/***/ "G9WS":
/***/ ((module) => {

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : {
    "default": obj
  };
}

module.exports = _interopRequireDefault;
module.exports.default = module.exports, module.exports.__esModule = true;

/***/ }),

/***/ "Vuz2":
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


var _interopRequireDefault = __webpack_require__("G9WS");

exports.__esModule = true;
exports.getTileGidMap = getTileGidMap;
exports.fixTiledInfo = fixTiledInfo;
exports.fixLayout = fixLayout;

var _forEach = _interopRequireDefault(__webpack_require__("RXMP"));

var _slice = _interopRequireDefault(__webpack_require__("UtpJ"));

var _indexOf = _interopRequireDefault(__webpack_require__("ZbhI"));

/**
 * 获取 tiledJson 里 tiled 的 gid map
 * @param {Object} tiledJsonData tiled 生成的产物
 * @returns 
 */
function getTileGidMap(tiledJsonData) {
  var _context;

  var gidMap = {};
  (0, _forEach["default"])(_context = tiledJsonData.tilesets).call(_context, function (tileset, index) {
    var _context2;

    var firstgid = tileset.firstgid;
    (0, _forEach["default"])(_context2 = tileset.tiles).call(_context2, function (tile, _index) {
      tile.tilesetsIndex = index;
      var gid = firstgid + _index;
      tile.gid = gid;
      gidMap[gid] = tile;
    });
  });
  return gidMap;
}
/**
 * 属性转换
 * 对逗号分隔符的，转换成数组
 * 1. 'aaa' => 'aaa'
 * 2. 'aaa,bbb' => ['aaa', 'bbb'] 
 * @returns 
 */


function parseValue(value) {
  var _value = value;

  if (typeof _value === 'string') {
    var valueArr = _value.split(',');

    if (valueArr.length > 1) {
      _value = valueArr;
    }
  }

  return _value;
}
/**
 * 获取 properties object
 * @param {Object} drawInfo tiled 生成的 layer/object 配置信息，
 * [
 *   {
        "name": "layoutRef",
        "type": "string",
        "value": "left,top"
      }
 * ]
 */


function getProperties(tiledItemInfo) {
  if (tiledItemInfo === void 0) {
    tiledItemInfo = {};
  }

  var _tiledItemInfo = tiledItemInfo,
      _tiledItemInfo$proper = _tiledItemInfo.properties,
      properties = _tiledItemInfo$proper === void 0 ? [] : _tiledItemInfo$proper;
  var obj = {};
  (0, _forEach["default"])(properties).call(properties, function (p) {
    var value = parseValue(p.value);

    if (!obj[p.name]) {
      obj[p.name] = value;
    } else {
      if (Object.prototype.toString.call(obj[p.name]) !== '[object Array]') {
        obj[p.name] = [obj[p.name]];
      }

      obj[p.name].push(value);
    }
  });
  return obj;
}
/**
 * 重新组装渲染数据
 * @tiledItemInfo {Object} Tiled 原始产物 
 * @type {('layer'|'sprite'|'container')} 元素类型 layer|sprite|container
 * @globalOpation {Object} 全局配置
 */


function fixTiledInfo(tiledItemInfo, type, globalOpation) {
  if (tiledItemInfo === void 0) {
    tiledItemInfo = {};
  }

  if (type === void 0) {
    type = '';
  }

  var isSprite = type === 'sprite';
  var info = {
    name: tiledItemInfo.name || '',
    type: type,
    opacity: typeof tiledItemInfo.opacity === 'number' ? tiledItemInfo.opacity : 1,
    visible: tiledItemInfo.visible,
    height: tiledItemInfo.height,
    width: tiledItemInfo.width,
    scale: 1,
    x: 0,
    y: 0,
    anchor: {
      x: isSprite ? 0.5 : 0,
      y: isSprite ? 0.5 : 0
    },
    rotation: 0
  };
  info.properties = getProperties(tiledItemInfo); // Tiled 产物坐标等修正

  var layoutInfo = calcPosAndRotation(tiledItemInfo, isSprite);
  info.x = layoutInfo.x;
  info.y = layoutInfo.y;
  info.rotation = layoutInfo.rotation; // 布局定位适配

  var _layout = fixLayout(info, globalOpation);

  info.x = _layout.x;
  info.y = _layout.y;
  return info;
}
/**
 * 求三角形长边
 * @param {number} a
 * @param {number} b
 * @returns 
 */


function trigonometric(a, b) {
  a = Number(a);
  b = Number(b);
  return Math.sqrt(a * a + b * b);
}
/**
 * 解决两个问题
 * 1. tiled 的元素 anchor 默认是在左下，而且无法调整，这和 pixi 的不相符
 * 2. tiled 在旋转的同时，会根据原图片左下点的实际绝对坐标，调整 x/y 坐标值，非常反人类，需要进行计算修正
 * > https://discourse.mapeditor.org/t/why-does-rotation-change-x-y/4086
 * @param {object} drawInfo tiled 生成的 layer/object 配置信息，
 * @param {boolean} canRotate 是否旋转
 * @return {object} { x, y, rotation }
 */


function calcPosAndRotation(drawInfo, canRotate) {
  if (canRotate === void 0) {
    canRotate = false;
  }

  var gid = drawInfo.gid,
      _drawInfo$x = drawInfo.x,
      x = _drawInfo$x === void 0 ? 0 : _drawInfo$x,
      _drawInfo$y = drawInfo.y,
      y = _drawInfo$y === void 0 ? 0 : _drawInfo$y,
      _drawInfo$offsetx = drawInfo.offsetx,
      offsetx = _drawInfo$offsetx === void 0 ? 0 : _drawInfo$offsetx,
      _drawInfo$offsety = drawInfo.offsety,
      offsety = _drawInfo$offsety === void 0 ? 0 : _drawInfo$offsety,
      _drawInfo$height = drawInfo.height,
      height = _drawInfo$height === void 0 ? 0 : _drawInfo$height,
      _drawInfo$width = drawInfo.width,
      width = _drawInfo$width === void 0 ? 0 : _drawInfo$width,
      _drawInfo$rotation = drawInfo.rotation,
      rotation = _drawInfo$rotation === void 0 ? 0 : _drawInfo$rotation; // 默认修正到左上角

  var pos = {
    x: x || offsetx,
    y: y || offsety,
    rotation: 0
  };

  if (gid) {
    pos = {
      x: x || offsetx,
      y: (y || offsety) - height,
      rotation: 0
    };
  } // 图片左下角 anchor 位置和旋转角度的修正


  if (canRotate) {
    if (rotation) {
      var _w2 = width / 2,
          // 1/2 宽度
      _h2 = height / 2; // 1/2 高度


      var radius = trigonometric(_w2, _h2); // 半径

      var originDeg = -Math.atan(_w2 / _h2); // 原始左下角的弧度值

      var deg = originDeg - rotation / 180 * Math.PI; // 当前左下角的弧度值

      /*
      原始公式
      设：
        tiled 旋转后原图左下角绝对坐标主为(a, b)
        不旋转原图左下角坐标绘制坐标为(x, y)
      x + w / 2 + R * sinA = a;
      y - h / 2 + R * cosA = b;
      */

      var _x = x - _w2 - radius * Math.sin(deg);

      var _y = y + _h2 - radius * Math.cos(deg);

      pos.x = _x;
      pos.y = _y - height;
    }

    pos.x = pos.x + width / 2;
    pos.y = pos.y + height / 2;
    pos.rotation = rotation;
  }

  return pos;
}
/**
 * 布局修正
 * 1. right / bottom 等定位
 */


function fixLayout(layoutInfo, globalOpation) {
  var _layout = {
    x: layoutInfo.x,
    y: layoutInfo.y
  }; //

  var layoutRef = parseValue(layoutInfo.layoutRef) || (layoutInfo.properties ? layoutInfo.properties.layoutRef || ['left', 'top'] : ['left', 'top']);

  if (layoutRef === 'center') {
    layoutRef = ['center', 'center'];
  }

  layoutRef = (0, _slice["default"])(layoutRef).call(layoutRef, 0, 2);
  var layoutRefX = (0, _indexOf["default"])(layoutRef).call(layoutRef, 'left') >= 0 ? 'left' : (0, _indexOf["default"])(layoutRef).call(layoutRef, 'right') >= 0 ? 'right' : (0, _indexOf["default"])(layoutRef).call(layoutRef, 'center') >= 0 ? 'center' : 'left';
  var layoutRefY = (0, _indexOf["default"])(layoutRef).call(layoutRef, 'top') >= 0 ? 'top' : (0, _indexOf["default"])(layoutRef).call(layoutRef, 'bottom') >= 0 ? 'bottom' : (0, _indexOf["default"])(layoutRef).call(layoutRef, 'center') >= 0 ? 'center' : 'top'; //

  if (layoutInfo.type === 'layer') {
    // 修正布局
    if (layoutRefX === 'left') {
      _layout.x = layoutInfo.x;
    } else if (layoutRefX === 'right') {
      _layout.x = globalOpation.canvasWidth - (globalOpation.width - layoutInfo.x);
    } else if (layoutRefX === 'center') {
      _layout.x = globalOpation.canvasWidth / 2 - (globalOpation.width / 2 - layoutInfo.x);
    }

    if (layoutRefY === 'top') {
      _layout.y = layoutInfo.y;
    } else if (layoutRefY === 'bottom') {
      _layout.y = globalOpation.canvasHeight - (globalOpation.height - layoutInfo.y);
    } else if (layoutRefY === 'center') {
      _layout.y = globalOpation.canvasHeight / 2 - (globalOpation.height / 2 - layoutInfo.y);
    }
  } //


  return _layout;
}

/***/ }),

/***/ "VsT0":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

__webpack_require__("qLPT");
var entryVirtual = __webpack_require__("oWnS");

module.exports = entryVirtual('Array').forEach;


/***/ }),

/***/ "O3vZ":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

__webpack_require__("u+ON");
var entryVirtual = __webpack_require__("oWnS");

module.exports = entryVirtual('Array').indexOf;


/***/ }),

/***/ "UQe+":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

__webpack_require__("QQub");
var entryVirtual = __webpack_require__("oWnS");

module.exports = entryVirtual('Array').map;


/***/ }),

/***/ "ks2j":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

__webpack_require__("HTq5");
var entryVirtual = __webpack_require__("oWnS");

module.exports = entryVirtual('Array').slice;


/***/ }),

/***/ "9Mno":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var indexOf = __webpack_require__("O3vZ");

var ArrayPrototype = Array.prototype;

module.exports = function (it) {
  var own = it.indexOf;
  return it === ArrayPrototype || (it instanceof Array && own === ArrayPrototype.indexOf) ? indexOf : own;
};


/***/ }),

/***/ "45KF":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var map = __webpack_require__("UQe+");

var ArrayPrototype = Array.prototype;

module.exports = function (it) {
  var own = it.map;
  return it === ArrayPrototype || (it instanceof Array && own === ArrayPrototype.map) ? map : own;
};


/***/ }),

/***/ "4zJj":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var slice = __webpack_require__("ks2j");

var ArrayPrototype = Array.prototype;

module.exports = function (it) {
  var own = it.slice;
  return it === ArrayPrototype || (it instanceof Array && own === ArrayPrototype.slice) ? slice : own;
};


/***/ }),

/***/ "zJQS":
/***/ ((module) => {

module.exports = function (it) {
  if (typeof it != 'function') {
    throw TypeError(String(it) + ' is not a function');
  } return it;
};


/***/ }),

/***/ "L5f0":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var isObject = __webpack_require__("39uu");

module.exports = function (it) {
  if (!isObject(it) && it !== null) {
    throw TypeError("Can't set " + String(it) + ' as a prototype');
  } return it;
};


/***/ }),

/***/ "xE4W":
/***/ ((module) => {

module.exports = function () { /* empty */ };


/***/ }),

/***/ "b42z":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var isObject = __webpack_require__("39uu");

module.exports = function (it) {
  if (!isObject(it)) {
    throw TypeError(String(it) + ' is not an object');
  } return it;
};


/***/ }),

/***/ "maQk":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";

var $forEach = __webpack_require__("3uAa").forEach;
var arrayMethodIsStrict = __webpack_require__("n2Hk");

var STRICT_METHOD = arrayMethodIsStrict('forEach');

// `Array.prototype.forEach` method implementation
// https://tc39.es/ecma262/#sec-array.prototype.foreach
module.exports = !STRICT_METHOD ? function forEach(callbackfn /* , thisArg */) {
  return $forEach(this, callbackfn, arguments.length > 1 ? arguments[1] : undefined);
// eslint-disable-next-line es/no-array-prototype-foreach -- safe
} : [].forEach;


/***/ }),

/***/ "Y4Ys":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var toIndexedObject = __webpack_require__("pCEo");
var toLength = __webpack_require__("ZyXh");
var toAbsoluteIndex = __webpack_require__("RQhY");

// `Array.prototype.{ indexOf, includes }` methods implementation
var createMethod = function (IS_INCLUDES) {
  return function ($this, el, fromIndex) {
    var O = toIndexedObject($this);
    var length = toLength(O.length);
    var index = toAbsoluteIndex(fromIndex, length);
    var value;
    // Array#includes uses SameValueZero equality algorithm
    // eslint-disable-next-line no-self-compare -- NaN check
    if (IS_INCLUDES && el != el) while (length > index) {
      value = O[index++];
      // eslint-disable-next-line no-self-compare -- NaN check
      if (value != value) return true;
    // Array#indexOf ignores holes, Array#includes - not
    } else for (;length > index; index++) {
      if ((IS_INCLUDES || index in O) && O[index] === el) return IS_INCLUDES || index || 0;
    } return !IS_INCLUDES && -1;
  };
};

module.exports = {
  // `Array.prototype.includes` method
  // https://tc39.es/ecma262/#sec-array.prototype.includes
  includes: createMethod(true),
  // `Array.prototype.indexOf` method
  // https://tc39.es/ecma262/#sec-array.prototype.indexof
  indexOf: createMethod(false)
};


/***/ }),

/***/ "3uAa":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var bind = __webpack_require__("ZBQp");
var IndexedObject = __webpack_require__("Y4yM");
var toObject = __webpack_require__("T/97");
var toLength = __webpack_require__("ZyXh");
var arraySpeciesCreate = __webpack_require__("Q0Rw");

var push = [].push;

// `Array.prototype.{ forEach, map, filter, some, every, find, findIndex, filterOut }` methods implementation
var createMethod = function (TYPE) {
  var IS_MAP = TYPE == 1;
  var IS_FILTER = TYPE == 2;
  var IS_SOME = TYPE == 3;
  var IS_EVERY = TYPE == 4;
  var IS_FIND_INDEX = TYPE == 6;
  var IS_FILTER_OUT = TYPE == 7;
  var NO_HOLES = TYPE == 5 || IS_FIND_INDEX;
  return function ($this, callbackfn, that, specificCreate) {
    var O = toObject($this);
    var self = IndexedObject(O);
    var boundFunction = bind(callbackfn, that, 3);
    var length = toLength(self.length);
    var index = 0;
    var create = specificCreate || arraySpeciesCreate;
    var target = IS_MAP ? create($this, length) : IS_FILTER || IS_FILTER_OUT ? create($this, 0) : undefined;
    var value, result;
    for (;length > index; index++) if (NO_HOLES || index in self) {
      value = self[index];
      result = boundFunction(value, index, O);
      if (TYPE) {
        if (IS_MAP) target[index] = result; // map
        else if (result) switch (TYPE) {
          case 3: return true;              // some
          case 5: return value;             // find
          case 6: return index;             // findIndex
          case 2: push.call(target, value); // filter
        } else switch (TYPE) {
          case 4: return false;             // every
          case 7: push.call(target, value); // filterOut
        }
      }
    }
    return IS_FIND_INDEX ? -1 : IS_SOME || IS_EVERY ? IS_EVERY : target;
  };
};

module.exports = {
  // `Array.prototype.forEach` method
  // https://tc39.es/ecma262/#sec-array.prototype.foreach
  forEach: createMethod(0),
  // `Array.prototype.map` method
  // https://tc39.es/ecma262/#sec-array.prototype.map
  map: createMethod(1),
  // `Array.prototype.filter` method
  // https://tc39.es/ecma262/#sec-array.prototype.filter
  filter: createMethod(2),
  // `Array.prototype.some` method
  // https://tc39.es/ecma262/#sec-array.prototype.some
  some: createMethod(3),
  // `Array.prototype.every` method
  // https://tc39.es/ecma262/#sec-array.prototype.every
  every: createMethod(4),
  // `Array.prototype.find` method
  // https://tc39.es/ecma262/#sec-array.prototype.find
  find: createMethod(5),
  // `Array.prototype.findIndex` method
  // https://tc39.es/ecma262/#sec-array.prototype.findIndex
  findIndex: createMethod(6),
  // `Array.prototype.filterOut` method
  // https://github.com/tc39/proposal-array-filtering
  filterOut: createMethod(7)
};


/***/ }),

/***/ "nJYk":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var fails = __webpack_require__("Bvq2");
var wellKnownSymbol = __webpack_require__("A2Ma");
var V8_VERSION = __webpack_require__("SqY4");

var SPECIES = wellKnownSymbol('species');

module.exports = function (METHOD_NAME) {
  // We can't use this feature detection in V8 since it causes
  // deoptimization and serious performance degradation
  // https://github.com/zloirock/core-js/issues/677
  return V8_VERSION >= 51 || !fails(function () {
    var array = [];
    var constructor = array.constructor = {};
    constructor[SPECIES] = function () {
      return { foo: 1 };
    };
    return array[METHOD_NAME](Boolean).foo !== 1;
  });
};


/***/ }),

/***/ "n2Hk":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";

var fails = __webpack_require__("Bvq2");

module.exports = function (METHOD_NAME, argument) {
  var method = [][METHOD_NAME];
  return !!method && fails(function () {
    // eslint-disable-next-line no-useless-call,no-throw-literal -- required for testing
    method.call(null, argument || function () { throw 1; }, 1);
  });
};


/***/ }),

/***/ "Q0Rw":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var isObject = __webpack_require__("39uu");
var isArray = __webpack_require__("YiBS");
var wellKnownSymbol = __webpack_require__("A2Ma");

var SPECIES = wellKnownSymbol('species');

// `ArraySpeciesCreate` abstract operation
// https://tc39.es/ecma262/#sec-arrayspeciescreate
module.exports = function (originalArray, length) {
  var C;
  if (isArray(originalArray)) {
    C = originalArray.constructor;
    // cross-realm fallback
    if (typeof C == 'function' && (C === Array || isArray(C.prototype))) C = undefined;
    else if (isObject(C)) {
      C = C[SPECIES];
      if (C === null) C = undefined;
    }
  } return new (C === undefined ? Array : C)(length === 0 ? 0 : length);
};


/***/ }),

/***/ "/EgQ":
/***/ ((module) => {

var toString = {}.toString;

module.exports = function (it) {
  return toString.call(it).slice(8, -1);
};


/***/ }),

/***/ "j5XY":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var TO_STRING_TAG_SUPPORT = __webpack_require__("1jut");
var classofRaw = __webpack_require__("/EgQ");
var wellKnownSymbol = __webpack_require__("A2Ma");

var TO_STRING_TAG = wellKnownSymbol('toStringTag');
// ES3 wrong here
var CORRECT_ARGUMENTS = classofRaw(function () { return arguments; }()) == 'Arguments';

// fallback for IE11 Script Access Denied error
var tryGet = function (it, key) {
  try {
    return it[key];
  } catch (error) { /* empty */ }
};

// getting tag from ES6+ `Object.prototype.toString`
module.exports = TO_STRING_TAG_SUPPORT ? classofRaw : function (it) {
  var O, tag, result;
  return it === undefined ? 'Undefined' : it === null ? 'Null'
    // @@toStringTag case
    : typeof (tag = tryGet(O = Object(it), TO_STRING_TAG)) == 'string' ? tag
    // builtinTag case
    : CORRECT_ARGUMENTS ? classofRaw(O)
    // ES3 arguments fallback
    : (result = classofRaw(O)) == 'Object' && typeof O.callee == 'function' ? 'Arguments' : result;
};


/***/ }),

/***/ "9fuf":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var fails = __webpack_require__("Bvq2");

module.exports = !fails(function () {
  function F() { /* empty */ }
  F.prototype.constructor = null;
  // eslint-disable-next-line es/no-object-getprototypeof -- required for testing
  return Object.getPrototypeOf(new F()) !== F.prototype;
});


/***/ }),

/***/ "9XUY":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";

var IteratorPrototype = __webpack_require__("u4PT").IteratorPrototype;
var create = __webpack_require__("SJYm");
var createPropertyDescriptor = __webpack_require__("LGyv");
var setToStringTag = __webpack_require__("KHTo");
var Iterators = __webpack_require__("dGO/");

var returnThis = function () { return this; };

module.exports = function (IteratorConstructor, NAME, next) {
  var TO_STRING_TAG = NAME + ' Iterator';
  IteratorConstructor.prototype = create(IteratorPrototype, { next: createPropertyDescriptor(1, next) });
  setToStringTag(IteratorConstructor, TO_STRING_TAG, false, true);
  Iterators[TO_STRING_TAG] = returnThis;
  return IteratorConstructor;
};


/***/ }),

/***/ "AnMC":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var DESCRIPTORS = __webpack_require__("wbIY");
var definePropertyModule = __webpack_require__("QYBB");
var createPropertyDescriptor = __webpack_require__("LGyv");

module.exports = DESCRIPTORS ? function (object, key, value) {
  return definePropertyModule.f(object, key, createPropertyDescriptor(1, value));
} : function (object, key, value) {
  object[key] = value;
  return object;
};


/***/ }),

/***/ "LGyv":
/***/ ((module) => {

module.exports = function (bitmap, value) {
  return {
    enumerable: !(bitmap & 1),
    configurable: !(bitmap & 2),
    writable: !(bitmap & 4),
    value: value
  };
};


/***/ }),

/***/ "bBVJ":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";

var toPrimitive = __webpack_require__("cWgI");
var definePropertyModule = __webpack_require__("QYBB");
var createPropertyDescriptor = __webpack_require__("LGyv");

module.exports = function (object, key, value) {
  var propertyKey = toPrimitive(key);
  if (propertyKey in object) definePropertyModule.f(object, propertyKey, createPropertyDescriptor(0, value));
  else object[propertyKey] = value;
};


/***/ }),

/***/ "QFZC":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";

var $ = __webpack_require__("pevS");
var createIteratorConstructor = __webpack_require__("9XUY");
var getPrototypeOf = __webpack_require__("V3kF");
var setPrototypeOf = __webpack_require__("7GIe");
var setToStringTag = __webpack_require__("KHTo");
var createNonEnumerableProperty = __webpack_require__("AnMC");
var redefine = __webpack_require__("1mbr");
var wellKnownSymbol = __webpack_require__("A2Ma");
var IS_PURE = __webpack_require__("cEKj");
var Iterators = __webpack_require__("dGO/");
var IteratorsCore = __webpack_require__("u4PT");

var IteratorPrototype = IteratorsCore.IteratorPrototype;
var BUGGY_SAFARI_ITERATORS = IteratorsCore.BUGGY_SAFARI_ITERATORS;
var ITERATOR = wellKnownSymbol('iterator');
var KEYS = 'keys';
var VALUES = 'values';
var ENTRIES = 'entries';

var returnThis = function () { return this; };

module.exports = function (Iterable, NAME, IteratorConstructor, next, DEFAULT, IS_SET, FORCED) {
  createIteratorConstructor(IteratorConstructor, NAME, next);

  var getIterationMethod = function (KIND) {
    if (KIND === DEFAULT && defaultIterator) return defaultIterator;
    if (!BUGGY_SAFARI_ITERATORS && KIND in IterablePrototype) return IterablePrototype[KIND];
    switch (KIND) {
      case KEYS: return function keys() { return new IteratorConstructor(this, KIND); };
      case VALUES: return function values() { return new IteratorConstructor(this, KIND); };
      case ENTRIES: return function entries() { return new IteratorConstructor(this, KIND); };
    } return function () { return new IteratorConstructor(this); };
  };

  var TO_STRING_TAG = NAME + ' Iterator';
  var INCORRECT_VALUES_NAME = false;
  var IterablePrototype = Iterable.prototype;
  var nativeIterator = IterablePrototype[ITERATOR]
    || IterablePrototype['@@iterator']
    || DEFAULT && IterablePrototype[DEFAULT];
  var defaultIterator = !BUGGY_SAFARI_ITERATORS && nativeIterator || getIterationMethod(DEFAULT);
  var anyNativeIterator = NAME == 'Array' ? IterablePrototype.entries || nativeIterator : nativeIterator;
  var CurrentIteratorPrototype, methods, KEY;

  // fix native
  if (anyNativeIterator) {
    CurrentIteratorPrototype = getPrototypeOf(anyNativeIterator.call(new Iterable()));
    if (IteratorPrototype !== Object.prototype && CurrentIteratorPrototype.next) {
      if (!IS_PURE && getPrototypeOf(CurrentIteratorPrototype) !== IteratorPrototype) {
        if (setPrototypeOf) {
          setPrototypeOf(CurrentIteratorPrototype, IteratorPrototype);
        } else if (typeof CurrentIteratorPrototype[ITERATOR] != 'function') {
          createNonEnumerableProperty(CurrentIteratorPrototype, ITERATOR, returnThis);
        }
      }
      // Set @@toStringTag to native iterators
      setToStringTag(CurrentIteratorPrototype, TO_STRING_TAG, true, true);
      if (IS_PURE) Iterators[TO_STRING_TAG] = returnThis;
    }
  }

  // fix Array.prototype.{ values, @@iterator }.name in V8 / FF
  if (DEFAULT == VALUES && nativeIterator && nativeIterator.name !== VALUES) {
    INCORRECT_VALUES_NAME = true;
    defaultIterator = function values() { return nativeIterator.call(this); };
  }

  // define iterator
  if ((!IS_PURE || FORCED) && IterablePrototype[ITERATOR] !== defaultIterator) {
    createNonEnumerableProperty(IterablePrototype, ITERATOR, defaultIterator);
  }
  Iterators[NAME] = defaultIterator;

  // export additional methods
  if (DEFAULT) {
    methods = {
      values: getIterationMethod(VALUES),
      keys: IS_SET ? defaultIterator : getIterationMethod(KEYS),
      entries: getIterationMethod(ENTRIES)
    };
    if (FORCED) for (KEY in methods) {
      if (BUGGY_SAFARI_ITERATORS || INCORRECT_VALUES_NAME || !(KEY in IterablePrototype)) {
        redefine(IterablePrototype, KEY, methods[KEY]);
      }
    } else $({ target: NAME, proto: true, forced: BUGGY_SAFARI_ITERATORS || INCORRECT_VALUES_NAME }, methods);
  }

  return methods;
};


/***/ }),

/***/ "wbIY":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var fails = __webpack_require__("Bvq2");

// Detect IE8's incomplete defineProperty implementation
module.exports = !fails(function () {
  // eslint-disable-next-line es/no-object-defineproperty -- required for testing
  return Object.defineProperty({}, 1, { get: function () { return 7; } })[1] != 7;
});


/***/ }),

/***/ "ejc7":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var global = __webpack_require__("OsYe");
var isObject = __webpack_require__("39uu");

var document = global.document;
// typeof document.createElement is 'object' in old IE
var EXISTS = isObject(document) && isObject(document.createElement);

module.exports = function (it) {
  return EXISTS ? document.createElement(it) : {};
};


/***/ }),

/***/ "eKLf":
/***/ ((module) => {

// iterable DOM collections
// flag - `iterable` interface - 'entries', 'keys', 'values', 'forEach' methods
module.exports = {
  CSSRuleList: 0,
  CSSStyleDeclaration: 0,
  CSSValueList: 0,
  ClientRectList: 0,
  DOMRectList: 0,
  DOMStringList: 0,
  DOMTokenList: 1,
  DataTransferItemList: 0,
  FileList: 0,
  HTMLAllCollection: 0,
  HTMLCollection: 0,
  HTMLFormElement: 0,
  HTMLSelectElement: 0,
  MediaList: 0,
  MimeTypeArray: 0,
  NamedNodeMap: 0,
  NodeList: 1,
  PaintRequestList: 0,
  Plugin: 0,
  PluginArray: 0,
  SVGLengthList: 0,
  SVGNumberList: 0,
  SVGPathSegList: 0,
  SVGPointList: 0,
  SVGStringList: 0,
  SVGTransformList: 0,
  SourceBufferList: 0,
  StyleSheetList: 0,
  TextTrackCueList: 0,
  TextTrackList: 0,
  TouchList: 0
};


/***/ }),

/***/ "lxfd":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var getBuiltIn = __webpack_require__("mIMY");

module.exports = getBuiltIn('navigator', 'userAgent') || '';


/***/ }),

/***/ "SqY4":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var global = __webpack_require__("OsYe");
var userAgent = __webpack_require__("lxfd");

var process = global.process;
var versions = process && process.versions;
var v8 = versions && versions.v8;
var match, version;

if (v8) {
  match = v8.split('.');
  version = match[0] < 4 ? 1 : match[0] + match[1];
} else if (userAgent) {
  match = userAgent.match(/Edge\/(\d+)/);
  if (!match || match[1] >= 74) {
    match = userAgent.match(/Chrome\/(\d+)/);
    if (match) version = match[1];
  }
}

module.exports = version && +version;


/***/ }),

/***/ "oWnS":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var path = __webpack_require__("dktu");

module.exports = function (CONSTRUCTOR) {
  return path[CONSTRUCTOR + 'Prototype'];
};


/***/ }),

/***/ "nleh":
/***/ ((module) => {

// IE8- don't enum bug keys
module.exports = [
  'constructor',
  'hasOwnProperty',
  'isPrototypeOf',
  'propertyIsEnumerable',
  'toLocaleString',
  'toString',
  'valueOf'
];


/***/ }),

/***/ "pevS":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";

var global = __webpack_require__("OsYe");
var getOwnPropertyDescriptor = __webpack_require__("RLqH").f;
var isForced = __webpack_require__("oOVA");
var path = __webpack_require__("dktu");
var bind = __webpack_require__("ZBQp");
var createNonEnumerableProperty = __webpack_require__("AnMC");
var has = __webpack_require__("eOcF");

var wrapConstructor = function (NativeConstructor) {
  var Wrapper = function (a, b, c) {
    if (this instanceof NativeConstructor) {
      switch (arguments.length) {
        case 0: return new NativeConstructor();
        case 1: return new NativeConstructor(a);
        case 2: return new NativeConstructor(a, b);
      } return new NativeConstructor(a, b, c);
    } return NativeConstructor.apply(this, arguments);
  };
  Wrapper.prototype = NativeConstructor.prototype;
  return Wrapper;
};

/*
  options.target      - name of the target object
  options.global      - target is the global object
  options.stat        - export as static methods of target
  options.proto       - export as prototype methods of target
  options.real        - real prototype method for the `pure` version
  options.forced      - export even if the native feature is available
  options.bind        - bind methods to the target, required for the `pure` version
  options.wrap        - wrap constructors to preventing global pollution, required for the `pure` version
  options.unsafe      - use the simple assignment of property instead of delete + defineProperty
  options.sham        - add a flag to not completely full polyfills
  options.enumerable  - export as enumerable property
  options.noTargetGet - prevent calling a getter on target
*/
module.exports = function (options, source) {
  var TARGET = options.target;
  var GLOBAL = options.global;
  var STATIC = options.stat;
  var PROTO = options.proto;

  var nativeSource = GLOBAL ? global : STATIC ? global[TARGET] : (global[TARGET] || {}).prototype;

  var target = GLOBAL ? path : path[TARGET] || (path[TARGET] = {});
  var targetPrototype = target.prototype;

  var FORCED, USE_NATIVE, VIRTUAL_PROTOTYPE;
  var key, sourceProperty, targetProperty, nativeProperty, resultProperty, descriptor;

  for (key in source) {
    FORCED = isForced(GLOBAL ? key : TARGET + (STATIC ? '.' : '#') + key, options.forced);
    // contains in native
    USE_NATIVE = !FORCED && nativeSource && has(nativeSource, key);

    targetProperty = target[key];

    if (USE_NATIVE) if (options.noTargetGet) {
      descriptor = getOwnPropertyDescriptor(nativeSource, key);
      nativeProperty = descriptor && descriptor.value;
    } else nativeProperty = nativeSource[key];

    // export native or implementation
    sourceProperty = (USE_NATIVE && nativeProperty) ? nativeProperty : source[key];

    if (USE_NATIVE && typeof targetProperty === typeof sourceProperty) continue;

    // bind timers to global for call from export context
    if (options.bind && USE_NATIVE) resultProperty = bind(sourceProperty, global);
    // wrap global constructors for prevent changs in this version
    else if (options.wrap && USE_NATIVE) resultProperty = wrapConstructor(sourceProperty);
    // make static versions for prototype methods
    else if (PROTO && typeof sourceProperty == 'function') resultProperty = bind(Function.call, sourceProperty);
    // default case
    else resultProperty = sourceProperty;

    // add a flag to not completely full polyfills
    if (options.sham || (sourceProperty && sourceProperty.sham) || (targetProperty && targetProperty.sham)) {
      createNonEnumerableProperty(resultProperty, 'sham', true);
    }

    target[key] = resultProperty;

    if (PROTO) {
      VIRTUAL_PROTOTYPE = TARGET + 'Prototype';
      if (!has(path, VIRTUAL_PROTOTYPE)) {
        createNonEnumerableProperty(path, VIRTUAL_PROTOTYPE, {});
      }
      // export virtual prototype methods
      path[VIRTUAL_PROTOTYPE][key] = sourceProperty;
      // export real prototype methods
      if (options.real && targetPrototype && !targetPrototype[key]) {
        createNonEnumerableProperty(targetPrototype, key, sourceProperty);
      }
    }
  }
};


/***/ }),

/***/ "Bvq2":
/***/ ((module) => {

module.exports = function (exec) {
  try {
    return !!exec();
  } catch (error) {
    return true;
  }
};


/***/ }),

/***/ "ZBQp":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var aFunction = __webpack_require__("zJQS");

// optional / simple context binding
module.exports = function (fn, that, length) {
  aFunction(fn);
  if (that === undefined) return fn;
  switch (length) {
    case 0: return function () {
      return fn.call(that);
    };
    case 1: return function (a) {
      return fn.call(that, a);
    };
    case 2: return function (a, b) {
      return fn.call(that, a, b);
    };
    case 3: return function (a, b, c) {
      return fn.call(that, a, b, c);
    };
  }
  return function (/* ...args */) {
    return fn.apply(that, arguments);
  };
};


/***/ }),

/***/ "mIMY":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var path = __webpack_require__("dktu");
var global = __webpack_require__("OsYe");

var aFunction = function (variable) {
  return typeof variable == 'function' ? variable : undefined;
};

module.exports = function (namespace, method) {
  return arguments.length < 2 ? aFunction(path[namespace]) || aFunction(global[namespace])
    : path[namespace] && path[namespace][method] || global[namespace] && global[namespace][method];
};


/***/ }),

/***/ "OsYe":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var check = function (it) {
  return it && it.Math == Math && it;
};

// https://github.com/zloirock/core-js/issues/86#issuecomment-115759028
module.exports =
  // eslint-disable-next-line es/no-global-this -- safe
  check(typeof globalThis == 'object' && globalThis) ||
  check(typeof window == 'object' && window) ||
  // eslint-disable-next-line no-restricted-globals -- safe
  check(typeof self == 'object' && self) ||
  check(typeof __webpack_require__.g == 'object' && __webpack_require__.g) ||
  // eslint-disable-next-line no-new-func -- fallback
  (function () { return this; })() || Function('return this')();


/***/ }),

/***/ "eOcF":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var toObject = __webpack_require__("T/97");

var hasOwnProperty = {}.hasOwnProperty;

module.exports = Object.hasOwn || function hasOwn(it, key) {
  return hasOwnProperty.call(toObject(it), key);
};


/***/ }),

/***/ "bpon":
/***/ ((module) => {

module.exports = {};


/***/ }),

/***/ "7b0v":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var getBuiltIn = __webpack_require__("mIMY");

module.exports = getBuiltIn('document', 'documentElement');


/***/ }),

/***/ "d7IX":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var DESCRIPTORS = __webpack_require__("wbIY");
var fails = __webpack_require__("Bvq2");
var createElement = __webpack_require__("ejc7");

// Thank's IE8 for his funny defineProperty
module.exports = !DESCRIPTORS && !fails(function () {
  // eslint-disable-next-line es/no-object-defineproperty -- requied for testing
  return Object.defineProperty(createElement('div'), 'a', {
    get: function () { return 7; }
  }).a != 7;
});


/***/ }),

/***/ "Y4yM":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var fails = __webpack_require__("Bvq2");
var classof = __webpack_require__("/EgQ");

var split = ''.split;

// fallback for non-array-like ES3 and non-enumerable old V8 strings
module.exports = fails(function () {
  // throws an error in rhino, see https://github.com/mozilla/rhino/issues/346
  // eslint-disable-next-line no-prototype-builtins -- safe
  return !Object('z').propertyIsEnumerable(0);
}) ? function (it) {
  return classof(it) == 'String' ? split.call(it, '') : Object(it);
} : Object;


/***/ }),

/***/ "6Jnn":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var store = __webpack_require__("doUz");

var functionToString = Function.toString;

// this helper broken in `core-js@3.4.1-3.4.4`, so we can't use `shared` helper
if (typeof store.inspectSource != 'function') {
  store.inspectSource = function (it) {
    return functionToString.call(it);
  };
}

module.exports = store.inspectSource;


/***/ }),

/***/ "L1rz":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var NATIVE_WEAK_MAP = __webpack_require__("lulC");
var global = __webpack_require__("OsYe");
var isObject = __webpack_require__("39uu");
var createNonEnumerableProperty = __webpack_require__("AnMC");
var objectHas = __webpack_require__("eOcF");
var shared = __webpack_require__("doUz");
var sharedKey = __webpack_require__("su3n");
var hiddenKeys = __webpack_require__("bpon");

var OBJECT_ALREADY_INITIALIZED = 'Object already initialized';
var WeakMap = global.WeakMap;
var set, get, has;

var enforce = function (it) {
  return has(it) ? get(it) : set(it, {});
};

var getterFor = function (TYPE) {
  return function (it) {
    var state;
    if (!isObject(it) || (state = get(it)).type !== TYPE) {
      throw TypeError('Incompatible receiver, ' + TYPE + ' required');
    } return state;
  };
};

if (NATIVE_WEAK_MAP || shared.state) {
  var store = shared.state || (shared.state = new WeakMap());
  var wmget = store.get;
  var wmhas = store.has;
  var wmset = store.set;
  set = function (it, metadata) {
    if (wmhas.call(store, it)) throw new TypeError(OBJECT_ALREADY_INITIALIZED);
    metadata.facade = it;
    wmset.call(store, it, metadata);
    return metadata;
  };
  get = function (it) {
    return wmget.call(store, it) || {};
  };
  has = function (it) {
    return wmhas.call(store, it);
  };
} else {
  var STATE = sharedKey('state');
  hiddenKeys[STATE] = true;
  set = function (it, metadata) {
    if (objectHas(it, STATE)) throw new TypeError(OBJECT_ALREADY_INITIALIZED);
    metadata.facade = it;
    createNonEnumerableProperty(it, STATE, metadata);
    return metadata;
  };
  get = function (it) {
    return objectHas(it, STATE) ? it[STATE] : {};
  };
  has = function (it) {
    return objectHas(it, STATE);
  };
}

module.exports = {
  set: set,
  get: get,
  has: has,
  enforce: enforce,
  getterFor: getterFor
};


/***/ }),

/***/ "YiBS":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var classof = __webpack_require__("/EgQ");

// `IsArray` abstract operation
// https://tc39.es/ecma262/#sec-isarray
// eslint-disable-next-line es/no-array-isarray -- safe
module.exports = Array.isArray || function isArray(arg) {
  return classof(arg) == 'Array';
};


/***/ }),

/***/ "oOVA":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var fails = __webpack_require__("Bvq2");

var replacement = /#|\.prototype\./;

var isForced = function (feature, detection) {
  var value = data[normalize(feature)];
  return value == POLYFILL ? true
    : value == NATIVE ? false
    : typeof detection == 'function' ? fails(detection)
    : !!detection;
};

var normalize = isForced.normalize = function (string) {
  return String(string).replace(replacement, '.').toLowerCase();
};

var data = isForced.data = {};
var NATIVE = isForced.NATIVE = 'N';
var POLYFILL = isForced.POLYFILL = 'P';

module.exports = isForced;


/***/ }),

/***/ "39uu":
/***/ ((module) => {

module.exports = function (it) {
  return typeof it === 'object' ? it !== null : typeof it === 'function';
};


/***/ }),

/***/ "cEKj":
/***/ ((module) => {

module.exports = true;


/***/ }),

/***/ "u4PT":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";

var fails = __webpack_require__("Bvq2");
var getPrototypeOf = __webpack_require__("V3kF");
var createNonEnumerableProperty = __webpack_require__("AnMC");
var has = __webpack_require__("eOcF");
var wellKnownSymbol = __webpack_require__("A2Ma");
var IS_PURE = __webpack_require__("cEKj");

var ITERATOR = wellKnownSymbol('iterator');
var BUGGY_SAFARI_ITERATORS = false;

var returnThis = function () { return this; };

// `%IteratorPrototype%` object
// https://tc39.es/ecma262/#sec-%iteratorprototype%-object
var IteratorPrototype, PrototypeOfArrayIteratorPrototype, arrayIterator;

/* eslint-disable es/no-array-prototype-keys -- safe */
if ([].keys) {
  arrayIterator = [].keys();
  // Safari 8 has buggy iterators w/o `next`
  if (!('next' in arrayIterator)) BUGGY_SAFARI_ITERATORS = true;
  else {
    PrototypeOfArrayIteratorPrototype = getPrototypeOf(getPrototypeOf(arrayIterator));
    if (PrototypeOfArrayIteratorPrototype !== Object.prototype) IteratorPrototype = PrototypeOfArrayIteratorPrototype;
  }
}

var NEW_ITERATOR_PROTOTYPE = IteratorPrototype == undefined || fails(function () {
  var test = {};
  // FF44- legacy iterators case
  return IteratorPrototype[ITERATOR].call(test) !== test;
});

if (NEW_ITERATOR_PROTOTYPE) IteratorPrototype = {};

// `%IteratorPrototype%[@@iterator]()` method
// https://tc39.es/ecma262/#sec-%iteratorprototype%-@@iterator
if ((!IS_PURE || NEW_ITERATOR_PROTOTYPE) && !has(IteratorPrototype, ITERATOR)) {
  createNonEnumerableProperty(IteratorPrototype, ITERATOR, returnThis);
}

module.exports = {
  IteratorPrototype: IteratorPrototype,
  BUGGY_SAFARI_ITERATORS: BUGGY_SAFARI_ITERATORS
};


/***/ }),

/***/ "dGO/":
/***/ ((module) => {

module.exports = {};


/***/ }),

/***/ "HmPo":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

/* eslint-disable es/no-symbol -- required for testing */
var V8_VERSION = __webpack_require__("SqY4");
var fails = __webpack_require__("Bvq2");

// eslint-disable-next-line es/no-object-getownpropertysymbols -- required for testing
module.exports = !!Object.getOwnPropertySymbols && !fails(function () {
  var symbol = Symbol();
  // Chrome 38 Symbol has incorrect toString conversion
  // `get-own-property-symbols` polyfill symbols converted to object are not Symbol instances
  return !String(symbol) || !(Object(symbol) instanceof Symbol) ||
    // Chrome 38-40 symbols are not inherited from DOM collections prototypes to instances
    !Symbol.sham && V8_VERSION && V8_VERSION < 41;
});


/***/ }),

/***/ "lulC":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var global = __webpack_require__("OsYe");
var inspectSource = __webpack_require__("6Jnn");

var WeakMap = global.WeakMap;

module.exports = typeof WeakMap === 'function' && /native code/.test(inspectSource(WeakMap));


/***/ }),

/***/ "SJYm":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var anObject = __webpack_require__("b42z");
var defineProperties = __webpack_require__("wjB2");
var enumBugKeys = __webpack_require__("nleh");
var hiddenKeys = __webpack_require__("bpon");
var html = __webpack_require__("7b0v");
var documentCreateElement = __webpack_require__("ejc7");
var sharedKey = __webpack_require__("su3n");

var GT = '>';
var LT = '<';
var PROTOTYPE = 'prototype';
var SCRIPT = 'script';
var IE_PROTO = sharedKey('IE_PROTO');

var EmptyConstructor = function () { /* empty */ };

var scriptTag = function (content) {
  return LT + SCRIPT + GT + content + LT + '/' + SCRIPT + GT;
};

// Create object with fake `null` prototype: use ActiveX Object with cleared prototype
var NullProtoObjectViaActiveX = function (activeXDocument) {
  activeXDocument.write(scriptTag(''));
  activeXDocument.close();
  var temp = activeXDocument.parentWindow.Object;
  activeXDocument = null; // avoid memory leak
  return temp;
};

// Create object with fake `null` prototype: use iframe Object with cleared prototype
var NullProtoObjectViaIFrame = function () {
  // Thrash, waste and sodomy: IE GC bug
  var iframe = documentCreateElement('iframe');
  var JS = 'java' + SCRIPT + ':';
  var iframeDocument;
  iframe.style.display = 'none';
  html.appendChild(iframe);
  // https://github.com/zloirock/core-js/issues/475
  iframe.src = String(JS);
  iframeDocument = iframe.contentWindow.document;
  iframeDocument.open();
  iframeDocument.write(scriptTag('document.F=Object'));
  iframeDocument.close();
  return iframeDocument.F;
};

// Check for document.domain and active x support
// No need to use active x approach when document.domain is not set
// see https://github.com/es-shims/es5-shim/issues/150
// variation of https://github.com/kitcambridge/es5-shim/commit/4f738ac066346
// avoid IE GC bug
var activeXDocument;
var NullProtoObject = function () {
  try {
    /* global ActiveXObject -- old IE */
    activeXDocument = document.domain && new ActiveXObject('htmlfile');
  } catch (error) { /* ignore */ }
  NullProtoObject = activeXDocument ? NullProtoObjectViaActiveX(activeXDocument) : NullProtoObjectViaIFrame();
  var length = enumBugKeys.length;
  while (length--) delete NullProtoObject[PROTOTYPE][enumBugKeys[length]];
  return NullProtoObject();
};

hiddenKeys[IE_PROTO] = true;

// `Object.create` method
// https://tc39.es/ecma262/#sec-object.create
module.exports = Object.create || function create(O, Properties) {
  var result;
  if (O !== null) {
    EmptyConstructor[PROTOTYPE] = anObject(O);
    result = new EmptyConstructor();
    EmptyConstructor[PROTOTYPE] = null;
    // add "__proto__" for Object.getPrototypeOf polyfill
    result[IE_PROTO] = O;
  } else result = NullProtoObject();
  return Properties === undefined ? result : defineProperties(result, Properties);
};


/***/ }),

/***/ "wjB2":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var DESCRIPTORS = __webpack_require__("wbIY");
var definePropertyModule = __webpack_require__("QYBB");
var anObject = __webpack_require__("b42z");
var objectKeys = __webpack_require__("oBZR");

// `Object.defineProperties` method
// https://tc39.es/ecma262/#sec-object.defineproperties
// eslint-disable-next-line es/no-object-defineproperties -- safe
module.exports = DESCRIPTORS ? Object.defineProperties : function defineProperties(O, Properties) {
  anObject(O);
  var keys = objectKeys(Properties);
  var length = keys.length;
  var index = 0;
  var key;
  while (length > index) definePropertyModule.f(O, key = keys[index++], Properties[key]);
  return O;
};


/***/ }),

/***/ "QYBB":
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

var DESCRIPTORS = __webpack_require__("wbIY");
var IE8_DOM_DEFINE = __webpack_require__("d7IX");
var anObject = __webpack_require__("b42z");
var toPrimitive = __webpack_require__("cWgI");

// eslint-disable-next-line es/no-object-defineproperty -- safe
var $defineProperty = Object.defineProperty;

// `Object.defineProperty` method
// https://tc39.es/ecma262/#sec-object.defineproperty
exports.f = DESCRIPTORS ? $defineProperty : function defineProperty(O, P, Attributes) {
  anObject(O);
  P = toPrimitive(P, true);
  anObject(Attributes);
  if (IE8_DOM_DEFINE) try {
    return $defineProperty(O, P, Attributes);
  } catch (error) { /* empty */ }
  if ('get' in Attributes || 'set' in Attributes) throw TypeError('Accessors not supported');
  if ('value' in Attributes) O[P] = Attributes.value;
  return O;
};


/***/ }),

/***/ "RLqH":
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

var DESCRIPTORS = __webpack_require__("wbIY");
var propertyIsEnumerableModule = __webpack_require__("cEPT");
var createPropertyDescriptor = __webpack_require__("LGyv");
var toIndexedObject = __webpack_require__("pCEo");
var toPrimitive = __webpack_require__("cWgI");
var has = __webpack_require__("eOcF");
var IE8_DOM_DEFINE = __webpack_require__("d7IX");

// eslint-disable-next-line es/no-object-getownpropertydescriptor -- safe
var $getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;

// `Object.getOwnPropertyDescriptor` method
// https://tc39.es/ecma262/#sec-object.getownpropertydescriptor
exports.f = DESCRIPTORS ? $getOwnPropertyDescriptor : function getOwnPropertyDescriptor(O, P) {
  O = toIndexedObject(O);
  P = toPrimitive(P, true);
  if (IE8_DOM_DEFINE) try {
    return $getOwnPropertyDescriptor(O, P);
  } catch (error) { /* empty */ }
  if (has(O, P)) return createPropertyDescriptor(!propertyIsEnumerableModule.f.call(O, P), O[P]);
};


/***/ }),

/***/ "V3kF":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var has = __webpack_require__("eOcF");
var toObject = __webpack_require__("T/97");
var sharedKey = __webpack_require__("su3n");
var CORRECT_PROTOTYPE_GETTER = __webpack_require__("9fuf");

var IE_PROTO = sharedKey('IE_PROTO');
var ObjectPrototype = Object.prototype;

// `Object.getPrototypeOf` method
// https://tc39.es/ecma262/#sec-object.getprototypeof
// eslint-disable-next-line es/no-object-getprototypeof -- safe
module.exports = CORRECT_PROTOTYPE_GETTER ? Object.getPrototypeOf : function (O) {
  O = toObject(O);
  if (has(O, IE_PROTO)) return O[IE_PROTO];
  if (typeof O.constructor == 'function' && O instanceof O.constructor) {
    return O.constructor.prototype;
  } return O instanceof Object ? ObjectPrototype : null;
};


/***/ }),

/***/ "syO3":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var has = __webpack_require__("eOcF");
var toIndexedObject = __webpack_require__("pCEo");
var indexOf = __webpack_require__("Y4Ys").indexOf;
var hiddenKeys = __webpack_require__("bpon");

module.exports = function (object, names) {
  var O = toIndexedObject(object);
  var i = 0;
  var result = [];
  var key;
  for (key in O) !has(hiddenKeys, key) && has(O, key) && result.push(key);
  // Don't enum bug & hidden keys
  while (names.length > i) if (has(O, key = names[i++])) {
    ~indexOf(result, key) || result.push(key);
  }
  return result;
};


/***/ }),

/***/ "oBZR":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var internalObjectKeys = __webpack_require__("syO3");
var enumBugKeys = __webpack_require__("nleh");

// `Object.keys` method
// https://tc39.es/ecma262/#sec-object.keys
// eslint-disable-next-line es/no-object-keys -- safe
module.exports = Object.keys || function keys(O) {
  return internalObjectKeys(O, enumBugKeys);
};


/***/ }),

/***/ "cEPT":
/***/ ((__unused_webpack_module, exports) => {

"use strict";

var $propertyIsEnumerable = {}.propertyIsEnumerable;
// eslint-disable-next-line es/no-object-getownpropertydescriptor -- safe
var getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;

// Nashorn ~ JDK8 bug
var NASHORN_BUG = getOwnPropertyDescriptor && !$propertyIsEnumerable.call({ 1: 2 }, 1);

// `Object.prototype.propertyIsEnumerable` method implementation
// https://tc39.es/ecma262/#sec-object.prototype.propertyisenumerable
exports.f = NASHORN_BUG ? function propertyIsEnumerable(V) {
  var descriptor = getOwnPropertyDescriptor(this, V);
  return !!descriptor && descriptor.enumerable;
} : $propertyIsEnumerable;


/***/ }),

/***/ "7GIe":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

/* eslint-disable no-proto -- safe */
var anObject = __webpack_require__("b42z");
var aPossiblePrototype = __webpack_require__("L5f0");

// `Object.setPrototypeOf` method
// https://tc39.es/ecma262/#sec-object.setprototypeof
// Works with __proto__ only. Old v8 can't work with null proto objects.
// eslint-disable-next-line es/no-object-setprototypeof -- safe
module.exports = Object.setPrototypeOf || ('__proto__' in {} ? function () {
  var CORRECT_SETTER = false;
  var test = {};
  var setter;
  try {
    // eslint-disable-next-line es/no-object-getownpropertydescriptor -- safe
    setter = Object.getOwnPropertyDescriptor(Object.prototype, '__proto__').set;
    setter.call(test, []);
    CORRECT_SETTER = test instanceof Array;
  } catch (error) { /* empty */ }
  return function setPrototypeOf(O, proto) {
    anObject(O);
    aPossiblePrototype(proto);
    if (CORRECT_SETTER) setter.call(O, proto);
    else O.__proto__ = proto;
    return O;
  };
}() : undefined);


/***/ }),

/***/ "HAoi":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";

var TO_STRING_TAG_SUPPORT = __webpack_require__("1jut");
var classof = __webpack_require__("j5XY");

// `Object.prototype.toString` method implementation
// https://tc39.es/ecma262/#sec-object.prototype.tostring
module.exports = TO_STRING_TAG_SUPPORT ? {}.toString : function toString() {
  return '[object ' + classof(this) + ']';
};


/***/ }),

/***/ "dktu":
/***/ ((module) => {

module.exports = {};


/***/ }),

/***/ "1mbr":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var createNonEnumerableProperty = __webpack_require__("AnMC");

module.exports = function (target, key, value, options) {
  if (options && options.enumerable) target[key] = value;
  else createNonEnumerableProperty(target, key, value);
};


/***/ }),

/***/ "GHVm":
/***/ ((module) => {

// `RequireObjectCoercible` abstract operation
// https://tc39.es/ecma262/#sec-requireobjectcoercible
module.exports = function (it) {
  if (it == undefined) throw TypeError("Can't call method on " + it);
  return it;
};


/***/ }),

/***/ "j60x":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var global = __webpack_require__("OsYe");
var createNonEnumerableProperty = __webpack_require__("AnMC");

module.exports = function (key, value) {
  try {
    createNonEnumerableProperty(global, key, value);
  } catch (error) {
    global[key] = value;
  } return value;
};


/***/ }),

/***/ "KHTo":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var TO_STRING_TAG_SUPPORT = __webpack_require__("1jut");
var defineProperty = __webpack_require__("QYBB").f;
var createNonEnumerableProperty = __webpack_require__("AnMC");
var has = __webpack_require__("eOcF");
var toString = __webpack_require__("HAoi");
var wellKnownSymbol = __webpack_require__("A2Ma");

var TO_STRING_TAG = wellKnownSymbol('toStringTag');

module.exports = function (it, TAG, STATIC, SET_METHOD) {
  if (it) {
    var target = STATIC ? it : it.prototype;
    if (!has(target, TO_STRING_TAG)) {
      defineProperty(target, TO_STRING_TAG, { configurable: true, value: TAG });
    }
    if (SET_METHOD && !TO_STRING_TAG_SUPPORT) {
      createNonEnumerableProperty(target, 'toString', toString);
    }
  }
};


/***/ }),

/***/ "su3n":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var shared = __webpack_require__("1lkh");
var uid = __webpack_require__("PoCt");

var keys = shared('keys');

module.exports = function (key) {
  return keys[key] || (keys[key] = uid(key));
};


/***/ }),

/***/ "doUz":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var global = __webpack_require__("OsYe");
var setGlobal = __webpack_require__("j60x");

var SHARED = '__core-js_shared__';
var store = global[SHARED] || setGlobal(SHARED, {});

module.exports = store;


/***/ }),

/***/ "1lkh":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var IS_PURE = __webpack_require__("cEKj");
var store = __webpack_require__("doUz");

(module.exports = function (key, value) {
  return store[key] || (store[key] = value !== undefined ? value : {});
})('versions', []).push({
  version: '3.15.2',
  mode: IS_PURE ? 'pure' : 'global',
  copyright: '© 2021 Denis Pushkarev (zloirock.ru)'
});


/***/ }),

/***/ "RQhY":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var toInteger = __webpack_require__("FWHo");

var max = Math.max;
var min = Math.min;

// Helper for a popular repeating case of the spec:
// Let integer be ? ToInteger(index).
// If integer < 0, let result be max((length + integer), 0); else let result be min(integer, length).
module.exports = function (index, length) {
  var integer = toInteger(index);
  return integer < 0 ? max(integer + length, 0) : min(integer, length);
};


/***/ }),

/***/ "pCEo":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

// toObject with fallback for non-array-like ES3 strings
var IndexedObject = __webpack_require__("Y4yM");
var requireObjectCoercible = __webpack_require__("GHVm");

module.exports = function (it) {
  return IndexedObject(requireObjectCoercible(it));
};


/***/ }),

/***/ "FWHo":
/***/ ((module) => {

var ceil = Math.ceil;
var floor = Math.floor;

// `ToInteger` abstract operation
// https://tc39.es/ecma262/#sec-tointeger
module.exports = function (argument) {
  return isNaN(argument = +argument) ? 0 : (argument > 0 ? floor : ceil)(argument);
};


/***/ }),

/***/ "ZyXh":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var toInteger = __webpack_require__("FWHo");

var min = Math.min;

// `ToLength` abstract operation
// https://tc39.es/ecma262/#sec-tolength
module.exports = function (argument) {
  return argument > 0 ? min(toInteger(argument), 0x1FFFFFFFFFFFFF) : 0; // 2 ** 53 - 1 == 9007199254740991
};


/***/ }),

/***/ "T/97":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var requireObjectCoercible = __webpack_require__("GHVm");

// `ToObject` abstract operation
// https://tc39.es/ecma262/#sec-toobject
module.exports = function (argument) {
  return Object(requireObjectCoercible(argument));
};


/***/ }),

/***/ "cWgI":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var isObject = __webpack_require__("39uu");

// `ToPrimitive` abstract operation
// https://tc39.es/ecma262/#sec-toprimitive
// instead of the ES6 spec version, we didn't implement @@toPrimitive case
// and the second argument - flag - preferred type is a string
module.exports = function (input, PREFERRED_STRING) {
  if (!isObject(input)) return input;
  var fn, val;
  if (PREFERRED_STRING && typeof (fn = input.toString) == 'function' && !isObject(val = fn.call(input))) return val;
  if (typeof (fn = input.valueOf) == 'function' && !isObject(val = fn.call(input))) return val;
  if (!PREFERRED_STRING && typeof (fn = input.toString) == 'function' && !isObject(val = fn.call(input))) return val;
  throw TypeError("Can't convert object to primitive value");
};


/***/ }),

/***/ "1jut":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var wellKnownSymbol = __webpack_require__("A2Ma");

var TO_STRING_TAG = wellKnownSymbol('toStringTag');
var test = {};

test[TO_STRING_TAG] = 'z';

module.exports = String(test) === '[object z]';


/***/ }),

/***/ "PoCt":
/***/ ((module) => {

var id = 0;
var postfix = Math.random();

module.exports = function (key) {
  return 'Symbol(' + String(key === undefined ? '' : key) + ')_' + (++id + postfix).toString(36);
};


/***/ }),

/***/ "YtAO":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

/* eslint-disable es/no-symbol -- required for testing */
var NATIVE_SYMBOL = __webpack_require__("HmPo");

module.exports = NATIVE_SYMBOL
  && !Symbol.sham
  && typeof Symbol.iterator == 'symbol';


/***/ }),

/***/ "A2Ma":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var global = __webpack_require__("OsYe");
var shared = __webpack_require__("1lkh");
var has = __webpack_require__("eOcF");
var uid = __webpack_require__("PoCt");
var NATIVE_SYMBOL = __webpack_require__("HmPo");
var USE_SYMBOL_AS_UID = __webpack_require__("YtAO");

var WellKnownSymbolsStore = shared('wks');
var Symbol = global.Symbol;
var createWellKnownSymbol = USE_SYMBOL_AS_UID ? Symbol : Symbol && Symbol.withoutSetter || uid;

module.exports = function (name) {
  if (!has(WellKnownSymbolsStore, name) || !(NATIVE_SYMBOL || typeof WellKnownSymbolsStore[name] == 'string')) {
    if (NATIVE_SYMBOL && has(Symbol, name)) {
      WellKnownSymbolsStore[name] = Symbol[name];
    } else {
      WellKnownSymbolsStore[name] = createWellKnownSymbol('Symbol.' + name);
    }
  } return WellKnownSymbolsStore[name];
};


/***/ }),

/***/ "qLPT":
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {

"use strict";

var $ = __webpack_require__("pevS");
var forEach = __webpack_require__("maQk");

// `Array.prototype.forEach` method
// https://tc39.es/ecma262/#sec-array.prototype.foreach
// eslint-disable-next-line es/no-array-prototype-foreach -- safe
$({ target: 'Array', proto: true, forced: [].forEach != forEach }, {
  forEach: forEach
});


/***/ }),

/***/ "u+ON":
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {

"use strict";

/* eslint-disable es/no-array-prototype-indexof -- required for testing */
var $ = __webpack_require__("pevS");
var $indexOf = __webpack_require__("Y4Ys").indexOf;
var arrayMethodIsStrict = __webpack_require__("n2Hk");

var nativeIndexOf = [].indexOf;

var NEGATIVE_ZERO = !!nativeIndexOf && 1 / [1].indexOf(1, -0) < 0;
var STRICT_METHOD = arrayMethodIsStrict('indexOf');

// `Array.prototype.indexOf` method
// https://tc39.es/ecma262/#sec-array.prototype.indexof
$({ target: 'Array', proto: true, forced: NEGATIVE_ZERO || !STRICT_METHOD }, {
  indexOf: function indexOf(searchElement /* , fromIndex = 0 */) {
    return NEGATIVE_ZERO
      // convert -0 to +0
      ? nativeIndexOf.apply(this, arguments) || 0
      : $indexOf(this, searchElement, arguments.length > 1 ? arguments[1] : undefined);
  }
});


/***/ }),

/***/ "kQON":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";

var toIndexedObject = __webpack_require__("pCEo");
var addToUnscopables = __webpack_require__("xE4W");
var Iterators = __webpack_require__("dGO/");
var InternalStateModule = __webpack_require__("L1rz");
var defineIterator = __webpack_require__("QFZC");

var ARRAY_ITERATOR = 'Array Iterator';
var setInternalState = InternalStateModule.set;
var getInternalState = InternalStateModule.getterFor(ARRAY_ITERATOR);

// `Array.prototype.entries` method
// https://tc39.es/ecma262/#sec-array.prototype.entries
// `Array.prototype.keys` method
// https://tc39.es/ecma262/#sec-array.prototype.keys
// `Array.prototype.values` method
// https://tc39.es/ecma262/#sec-array.prototype.values
// `Array.prototype[@@iterator]` method
// https://tc39.es/ecma262/#sec-array.prototype-@@iterator
// `CreateArrayIterator` internal method
// https://tc39.es/ecma262/#sec-createarrayiterator
module.exports = defineIterator(Array, 'Array', function (iterated, kind) {
  setInternalState(this, {
    type: ARRAY_ITERATOR,
    target: toIndexedObject(iterated), // target
    index: 0,                          // next index
    kind: kind                         // kind
  });
// `%ArrayIteratorPrototype%.next` method
// https://tc39.es/ecma262/#sec-%arrayiteratorprototype%.next
}, function () {
  var state = getInternalState(this);
  var target = state.target;
  var kind = state.kind;
  var index = state.index++;
  if (!target || index >= target.length) {
    state.target = undefined;
    return { value: undefined, done: true };
  }
  if (kind == 'keys') return { value: index, done: false };
  if (kind == 'values') return { value: target[index], done: false };
  return { value: [index, target[index]], done: false };
}, 'values');

// argumentsList[@@iterator] is %ArrayProto_values%
// https://tc39.es/ecma262/#sec-createunmappedargumentsobject
// https://tc39.es/ecma262/#sec-createmappedargumentsobject
Iterators.Arguments = Iterators.Array;

// https://tc39.es/ecma262/#sec-array.prototype-@@unscopables
addToUnscopables('keys');
addToUnscopables('values');
addToUnscopables('entries');


/***/ }),

/***/ "QQub":
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {

"use strict";

var $ = __webpack_require__("pevS");
var $map = __webpack_require__("3uAa").map;
var arrayMethodHasSpeciesSupport = __webpack_require__("nJYk");

var HAS_SPECIES_SUPPORT = arrayMethodHasSpeciesSupport('map');

// `Array.prototype.map` method
// https://tc39.es/ecma262/#sec-array.prototype.map
// with adding support of @@species
$({ target: 'Array', proto: true, forced: !HAS_SPECIES_SUPPORT }, {
  map: function map(callbackfn /* , thisArg */) {
    return $map(this, callbackfn, arguments.length > 1 ? arguments[1] : undefined);
  }
});


/***/ }),

/***/ "HTq5":
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {

"use strict";

var $ = __webpack_require__("pevS");
var isObject = __webpack_require__("39uu");
var isArray = __webpack_require__("YiBS");
var toAbsoluteIndex = __webpack_require__("RQhY");
var toLength = __webpack_require__("ZyXh");
var toIndexedObject = __webpack_require__("pCEo");
var createProperty = __webpack_require__("bBVJ");
var wellKnownSymbol = __webpack_require__("A2Ma");
var arrayMethodHasSpeciesSupport = __webpack_require__("nJYk");

var HAS_SPECIES_SUPPORT = arrayMethodHasSpeciesSupport('slice');

var SPECIES = wellKnownSymbol('species');
var nativeSlice = [].slice;
var max = Math.max;

// `Array.prototype.slice` method
// https://tc39.es/ecma262/#sec-array.prototype.slice
// fallback for not array-like ES3 strings and DOM objects
$({ target: 'Array', proto: true, forced: !HAS_SPECIES_SUPPORT }, {
  slice: function slice(start, end) {
    var O = toIndexedObject(this);
    var length = toLength(O.length);
    var k = toAbsoluteIndex(start, length);
    var fin = toAbsoluteIndex(end === undefined ? length : end, length);
    // inline `ArraySpeciesCreate` for usage native `Array#slice` where it's possible
    var Constructor, result, n;
    if (isArray(O)) {
      Constructor = O.constructor;
      // cross-realm fallback
      if (typeof Constructor == 'function' && (Constructor === Array || isArray(Constructor.prototype))) {
        Constructor = undefined;
      } else if (isObject(Constructor)) {
        Constructor = Constructor[SPECIES];
        if (Constructor === null) Constructor = undefined;
      }
      if (Constructor === Array || Constructor === undefined) {
        return nativeSlice.call(O, k, fin);
      }
    }
    result = new (Constructor === undefined ? Array : Constructor)(max(fin - k, 0));
    for (n = 0; k < fin; k++, n++) if (k in O) createProperty(result, n, O[k]);
    result.length = n;
    return result;
  }
});


/***/ }),

/***/ "UUWy":
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {

__webpack_require__("kQON");
var DOMIterables = __webpack_require__("eKLf");
var global = __webpack_require__("OsYe");
var classof = __webpack_require__("j5XY");
var createNonEnumerableProperty = __webpack_require__("AnMC");
var Iterators = __webpack_require__("dGO/");
var wellKnownSymbol = __webpack_require__("A2Ma");

var TO_STRING_TAG = wellKnownSymbol('toStringTag');

for (var COLLECTION_NAME in DOMIterables) {
  var Collection = global[COLLECTION_NAME];
  var CollectionPrototype = Collection && Collection.prototype;
  if (CollectionPrototype && classof(CollectionPrototype) !== TO_STRING_TAG) {
    createNonEnumerableProperty(CollectionPrototype, TO_STRING_TAG, COLLECTION_NAME);
  }
  Iterators[COLLECTION_NAME] = Iterators.Array;
}


/***/ }),

/***/ "vA1p":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var parent = __webpack_require__("VsT0");

module.exports = parent;


/***/ }),

/***/ "JLQQ":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

__webpack_require__("UUWy");
var forEach = __webpack_require__("vA1p");
var classof = __webpack_require__("j5XY");
var ArrayPrototype = Array.prototype;

var DOMIterables = {
  DOMTokenList: true,
  NodeList: true
};

module.exports = function (it) {
  var own = it.forEach;
  return it === ArrayPrototype || (it instanceof Array && own === ArrayPrototype.forEach)
    // eslint-disable-next-line no-prototype-builtins -- safe
    || DOMIterables.hasOwnProperty(classof(it)) ? forEach : own;
};


/***/ }),

/***/ "J6x8":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var parent = __webpack_require__("9Mno");

module.exports = parent;


/***/ }),

/***/ "XGjS":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var parent = __webpack_require__("45KF");

module.exports = parent;


/***/ }),

/***/ "QDXk":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var parent = __webpack_require__("4zJj");

module.exports = parent;


/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/global */
/******/ 	(() => {
/******/ 		__webpack_require__.g = (function() {
/******/ 			if (typeof globalThis === 'object') return globalThis;
/******/ 			try {
/******/ 				return this || new Function('return this')();
/******/ 			} catch (e) {
/******/ 				if (typeof window === 'object') return window;
/******/ 			}
/******/ 		})();
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be in strict mode.
(() => {
"use strict";
var exports = __webpack_exports__;


var _interopRequireDefault = __webpack_require__("G9WS");

exports.__esModule = true;
exports.default = void 0;

var _map = _interopRequireDefault(__webpack_require__("FLGM"));

var _forEach = _interopRequireDefault(__webpack_require__("RXMP"));

var _common = __webpack_require__("Vuz2");

var TiledData = /*#__PURE__*/function () {
  /**
   * 
   * @param {Object} tiledJson 
   * @param {Object<module>} resource 
   */
  function TiledData(tiledJson, resource, canvasOption) {
    if (canvasOption === void 0) {
      canvasOption = {};
    }

    this.tiledJson = tiledJson;
    this.resource = resource;
    this.canvasOption = canvasOption;
    this.tiledGidMap = (0, _common.getTileGidMap)(tiledJson);
    this.renderInfo = this._getRenderInfo();
    this.itemMapByName = this._getItemMapByName();
  }

  var _proto = TiledData.prototype;

  _proto.getObjectByName = function getObjectByName(name) {
    return this.getObjectListByName(name)[0];
  };

  _proto.getObjectListByName = function getObjectListByName(name) {
    return this.itemMapByName[name] || [];
  }
  /**
   * 获取渲染树
   * @returns
   */
  ;

  _proto._getRenderInfo = function _getRenderInfo() {
    var _this = this;

    var layers = this.tiledJson.layers || [];
    var globalOption = {
      width: this.tiledJson.width,
      height: this.tiledJson.height,
      canvasWidth: this.canvasOption.width,
      canvasHeight: this.canvasOption.height
    };
    layers = (0, _map["default"])(layers).call(layers, function (layer) {
      var _context;

      var layerInfo = (0, _common.fixTiledInfo)(layer, 'layer', globalOption);
      layerInfo.objects = (0, _map["default"])(_context = layer.objects || []).call(_context, function (obj) {
        // 取图片
        var gid = obj.gid;
        var tileInfo = gid ? _this.tiledGidMap[gid] : null;
        var imageUrl = tileInfo ? _this.resource[tileInfo.image] : ''; //

        var objectInfo = (0, _common.fixTiledInfo)(obj, imageUrl ? 'sprite' : 'container', globalOption);

        if (imageUrl) {
          objectInfo.gid = gid;
          objectInfo.imageUrl = imageUrl;
          objectInfo.imageName = tileInfo.image;
        }

        return objectInfo;
      });
      return layerInfo;
    }); //

    var rootInfo = {
      x: 0,
      y: 0,
      type: 'layer',
      layoutRef: this.canvasOption.layoutRef || ''
    };

    var _layout = (0, _common.fixLayout)(rootInfo, globalOption);

    rootInfo.x = _layout.x;
    rootInfo.y = _layout.y;
    return {
      rootInfo: rootInfo,
      layers: layers
    };
  }
  /**
   * 获取有 name 的元素 map
   * @returns
   */
  ;

  _proto._getItemMapByName = function _getItemMapByName() {
    var _context2;

    var objectMap = {};
    (0, _forEach["default"])(_context2 = this.renderInfo.layers).call(_context2, function (layer) {
      var _context3;

      var name = layer.name;

      if (name) {
        objectMap[name] = objectMap[name] || [];
        objectMap[name].push(layer);
      }

      (0, _forEach["default"])(_context3 = layer.objects).call(_context3, function (obj) {
        var _name = obj.name;

        if (_name) {
          objectMap[_name] = objectMap[_name] || [];

          objectMap[_name].push(obj);
        }
      });
    });
    return objectMap;
  };

  return TiledData;
}();

exports.default = TiledData;
})();

/******/ 	return __webpack_exports__;
/******/ })()
;
});